/* xwGUI -- an X11-GUI for photo prints
 * Copyright (C) 2001 Stefan Kraus
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifndef _XWRESOURCE_H
#define _XWRESOURCE_H

#include <sys/stat.h>
#include <unistd.h>
#include <locale.h>
#include <string.h>

/*
  resource.C
*/

/* Print Resource to standart output */
/* #define printResource "True"; */

/* Load Resource & Check Language Code */
void xwInitResource(const char *source);
/* Free Resource Datas */
void xwFreeResource(void);
/* Install Path Check */
void xwInstallPath(const char *path);
/* Set Home Drawer */
void xwSetDrawer(const char *drawer);
/* Get Install Path */
const char * xwGetIP(const char *file);
/* Get Programm File */
char * xwGetFile(char *drawer,char *file);
/* Set Language Code */
void xwSetLang(const char *lang);
/* Get Language Code */
const char * xwGetLang(void);
/* Get Resource */
const char * xwGR(int lang,const char *resource,const char *def);

#endif